var requestify = require('requestify');
var config = require('./config');

var repository = {};

repository.getById = function(id) {
    var url = 'http://' + config.host + '/contractor/get/' + id;
    return new Promise(function(resolve, reject) {
        requestify.get(url).then(function(response) {
            var body = response.getBody();
            if (response.code == 200) {

                if (body.TipoErro) {
                    reject(null);
                    return;
                }

                if (!body.data) {
                    reject(null);
                    return;
                }

                resolve(body.data);
                return;
            } else {
                reject(null);
                return;
            }
        }).catch(function(ex) {
            throw ex;
        });
    });
};

repository.getConnections = function() {
    var url = `http://${config.host}/contractor/connection/list`;
    return new Promise(function(resolve, reject) {
        requestify.get(url).then(function(response) {
            var body = response.getBody();
            if (response.code == 200) {

                if (body.TipoErro) {
                    reject(null);
                    return;
                }

                if (!body.data) {
                    reject(null);
                    return;
                }

                resolve(body.data);
                return;
            } else {
                reject(null);
                return;
            }
        }).catch(function(ex) {
            throw ex;
        });
    });
};

repository.getConnectionsById = function(contractor_id, handle) {
    var url = `http://${config.host}/contractor/connection/getByApplicationHandle/${contractor_id}/${handle}`;
    return new Promise(function(resolve, reject) {
        requestify.get(url).then(function(response) {
            var body = response.getBody();
            if (response.code == 200) {

                if (body.TipoErro) {
                    reject(null);
                    return;
                }

                if (!body.data) {
                    reject(null);
                    return;
                }

                resolve(body.data);
                return;
            } else {
                reject(null);
                return;
            }
        }).catch(function(ex) {
            throw ex;
        });
    });
};

module.exports = repository;