var Linq = require("node-linq").LINQ;
var provider = {};

provider.getByContractorId = function(contratanteId, objectSchema) {

    var conexao = new Linq(global.DicionarioConexoes).Single(function(item) {
        return item.contratanteId == contratanteId;
    });

    var model = new Linq(conexao.models).SingleOrDefault(null, function(item) {
        return item.name == objectSchema.options.collection;
    });

    if (model) {
        return model.model;
    } else {

        var schema = objectSchema;
        var instanciaModel = conexao.instancia.model(objectSchema.options.collection, schema);

        conexao.models.push({ name: objectSchema.options.collection, model: instanciaModel });

        return instanciaModel;
    }
};

provider.getByContratanteId = function(contratanteId, objectSchema) {
    return provider.getByContractorId(contratanteId, objectSchema);
};

provider.getStaticConnectionByName = function(name, objectSchema) {

    var conexao = new Linq(global.DicionarioConexoesEstaticas).Single(function(item) {
        return item.name == name;
    });

    var model = new Linq(conexao.models).SingleOrDefault(null, function(item) {
        return item.name == objectSchema.options.collection;
    });

    if (model) {
        return model.model;
    } else {

        var schema = objectSchema;
        var instanciaModel = conexao.instancia.model(objectSchema.options.collection, schema);

        conexao.models.push({ name: objectSchema.options.collection, model: instanciaModel });

        return instanciaModel;
    }

};

module.exports = provider;